#!/usr/bin/perl

# common values

$datadir    = '../html/imaging/temp';	   # server-side directory to keep the uploaded images
$piccat     = '/imaging/temp';             # URL of the uploaded image files
$tmpnam     = "tmp-$$";                    # name for the tmp file
$savescript = '/cgi-bin/i_save.cgi';       # URL of the script i_save.cgi
$viewscript = '/cgi-bin/i_view.cgi';       # URL of the script i_save.cgi
$appletdir  = '/imaging/product/applet';   # URL of the applet directory


# print header

	print "Content-type: text/html\n\n";

# process upload ..

	$R = &getquery();
	rename( "$datadir/$tmpnam" , "$datadir/$R->{fname}" );
	
# .. and print answer

   &print_answer( 
	   viewscript => $viewscript,
	   file       => $piccat.'/'.&url_encode($R->{fname}),
   ); 
   
   exit;

######### s u b s #####################


sub getquery
{

   my $R = {};

   if( $ENV{CONTENT_TYPE} !~ /multipart/ )
   {
      &herror("Illegal call to application : multipart form data required");
   }

# save upload... 

	open(W,">$datadir/$tmpnam");
	binmode(W);
	binmode(STDIN);
	print W while(<STDIN>); 
	close(W);

   if(0)
   {
	   open(R,"$datadir/$tmpnam");
   	open(W,">$datadir/$tmpnam-1");
	   binmode(W);
	   binmode(R);
	   print W while(<R>); 
	   close(W);
	   close(R);
   }

# process upload

	$R = &parse_upload( "$datadir/$tmpnam" );
	$R;
}


sub print_answer
{
	my %a = @_;

	print <<EOT;
\#SETDOCTAG=_blank
\#SHOWDOCUMENT=$a{viewscript}?filename=$a{file}
EOT

}

sub parse_upload # (filename)
{
   my $f = shift;
   my $r = {}; # what to return 
   
   my ($delimiter,$D,@D,$n);
   
   open(R,$f)||return(undef);
   binmode(R);
   $delimiter = <R>; $delimiter =~ s/\s+$//;
   seek(R,0,0);
   
   $D = ''; while(<R>) { $D .= $_; } # read all to $D
   close(R);

   @D = split(/$delimiter/,$D); # split to very big chunks
   
   # empty - height - select - jpeg_quality - width - FILE - ...

   &get_uplovar($r,$D[1]);
   &get_uplovar($r,$D[2]);
   &get_uplovar($r,$D[3]);
   &get_uplovar($r,$D[4]);
   
# 1) file
   
   $D[5] =~ /\x0D\x0A\x0D\x0A/;
   $n = $`;
   $D[5] = $';
   $r->{len} = length($D[5])-2;
   $D[5] = substr($D[5],0,$r->{len});
   
# 1.1) filename
   
   $n =~ /filename=\"([^\"]+)\"/; $n = $1;
   $n =~ /([^\\\/]+)$/;
   $r->{fname} = $1;
   
   
# save picture to the same tmp-file
   
   open(W,">$f"); binmode(W); print W $D[5]; close(W);

   $r;

}

sub get_uplovar
{
   my $r = shift;
   my $s = shift;
   if(  $s !~ /name=\"([^\"]*)\"/ )
   {
      &herror("data not found in the input");
   }
   my $n = $1;
   $s =~ /\x0D\x0A\x0D\x0A(\S*)\x0D\x0A/;
   $r->{$n} = $1;
}

sub url_encode
{
	my $s = shift;
	$s;
}

sub herror
{
   print "<hr>".$_[0];
   exit;
}


